#include <ros/ros.h>
#include <std_msgs/Int32.h>

/*** Topicを受信すると呼ばれるコールバック関数 ***/
void onNumberSubscribed(const std_msgs::Int32 &msg)
{
  /*** 受信したデータを表示 ***/
  ROS_INFO("I heard: [%d]", msg.data);
}

int main(int argc, char **argv)
{
  /*** ROSノードの初期化 ***/
  ros::init(argc, argv, "subscriber");
  ros::NodeHandle nh;
  /*** SubscribeするTopicの設定＆コールバック関数の登録 ***/
  ros::Subscriber sub = nh.subscribe("number", 10, onNumberSubscribed);
  /*** コールバックを待機 ***/
  ros::spin();
  return 0;
}