#include <ros/ros.h>
#include <std_msgs/Int32.h>

int main(int argc, char **argv)
{
  /*** ROSノードの初期化 ***/
  ros::init(argc, argv, "publisher");
  ros::NodeHandle nh;
  /*** PublishするTopicの登録 ***/
  ros::Publisher pub = nh.advertise<std_msgs::Int32>("number", 10);
  /*** ループ間隔の設定 ***/
  ros::Rate loop_rate(1);
  /*** Publishする変数の定義 ***/
  std_msgs::Int32 cnt;
  cnt.data = 0;
  /*** 無限ループ***/
  while (ros::ok())
  {
    /*** 現在のcnt変数の値を表示 ***/
    ROS_INFO("Count : %d", cnt.data);
    /*** cnt変数をPublish ***/
    pub.publish(cnt);
    /*** cnt変数をインクリメント ***/
    cnt.data++;
    /*** ループ間隔が1秒になるように待機 ***/
    loop_rate.sleep();
  }
  return 0;
}