#include <ros/ros.h>
#include <std_srvs/Empty.h>

using namespace std_srvs;

/*** Serviceのコールバック関数 ***/
bool serviceSayHello(EmptyRequest &req, EmptyResponse &res)
{
  ROS_INFO("Hello World");
  return true;
}

int main(int argc, char **argv)
{
  /*** ROSノードの初期化 ***/
  ros::init(argc, argv, "service_server");
  ros::NodeHandle nh;
  /*** 提供するServiceの登録 ***/
  ros::ServiceServer srv = nh.advertiseService("say_hello", serviceSayHello);
  /*** コールバックを待機 ***/
  ros::spin();
  return 0;
}