#include <ros/ros.h>
#include <tutorial_service/ReadText.h>
#include <fstream>

using namespace tutorial_service;

/*** Serviceのコールバック関数 ***/
bool serviceReadText(ReadTextRequest &req, ReadTextResponse &res)
{
  /*** file_pathで指定されたファイルを開く ***/
  std::ifstream ifs(req.file_path);
  /*** ファイルが開けなかった場合falseを返す ***/
  if(ifs.fail()) return false;
  /*** ファイルの中身をすべて読み取る ***/
  std::string buffer;
  while(getline(ifs, buffer)){
    res.file_contents += buffer;
  }
  return true;
}

int main(int argc, char **argv)
{
  /*** ROSノードの初期化 ***/
  ros::init(argc, argv, "read_text");
  ros::NodeHandle nh;
  /*** 提供するServiceの登録 ***/
  ros::ServiceServer srv = nh.advertiseService("read_text", serviceReadText);
  /*** コールバックを待機 ***/
  ros::spin();
  return 0;
}