#include <ros/ros.h>

int main(int argc, char **argv)
{
  /*** ROSノードの初期化 ***/
  ros::init(argc, argv, "param_test");
  ros::NodeHandle nh;
  /*** Parameterの読み込み ***/
  std::string text = nh.param<std::string>("text", "Hello World");
  int repeat_times = nh.param<int>("repeat_times", 10);
  double frequency = nh.param<double>("frequency", 0.5);
  /*** 文字列の表示周期を設定 ***/
  ros::Rate loop_rate(frequency);
  /*** テキストの表示処理 ***/
  for(int i = 0; i < repeat_times; i++){
    ROS_INFO("%s", text.c_str());
    loop_rate.sleep();
  }
  return 0;
}