#include <ros/ros.h>
#include <std_msgs/String.h>
#include <std_srvs/Empty.h>

int main(int argc, char **argv)
{
  using std_msgs::String;
  using std_srvs::Empty;
  /*** ROSの初期化 ***/
  ros::init(argc, argv, "remote_client");
  ros::NodeHandle nh;
  /*** PublishするTopicの登録 ***/
  ros::Publisher pub = nh.advertise<String>("text", 10);
  /*** 利用するServiceの登録 ***/
  ros::ServiceClient cli = nh.serviceClient<Empty>("is_alive");
  /*** Serviceが利用できるまで待機 ***/
  Empty args;
  while(!cli.call(args)) ros::Duration(0.1).sleep();
  /*** Parameterの取得 ***/
  String str;
  str.data = nh.param<std::string>("text", "Hello World");
  /*** Topicを1Hz周期でPublish ***/
  ros::Rate loop_rate(1);
  while(ros::ok()){
    pub.publish(str);
    ROS_INFO("I said %s", str.data.c_str());
    loop_rate.sleep();
  }
  return 0;
}