#include <ros/ros.h>
#include <tutorial_service/ReadText.h>

int main(int argc, char** argv)
{
  /*** コマンドライン引数が足らない場合終了 ***/
  if(argc < 2){
    ROS_ERROR("Usage is %s [text_path]", argv[0]);
    return -1;
  }
  using tutorial_service::ReadText;
  /*** ROSノードの初期化 ***/
  ros::init(argc, argv, "print_text");
  ros::NodeHandle nh;
  /*** 利用するServiceの登録 ***/
  ros::ServiceClient cli = nh.serviceClient<ReadText>("read_text");
  /*** Serviceの呼び出し ***/
  ReadText args;
  args.request.file_path = argv[1];
  bool ret = cli.call(args);
  /*** 呼び出しに成功していれば内容を表示 ***/
  if(ret) ROS_INFO("%s", args.response.file_contents.c_str());
  else ROS_INFO("Failure");
  return 0;
}